Bug 1292926 - firewalld --new-service & malformed xml ??
firewalld --new-service & malformed xml ??
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: firewalld (Show other bugs)
7.1
x86_64 Linux
medium Severity low
: rc
: ---
Assigned To: Thomas Woerner
Jan Kepler
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-18 13:49 EST by lejeczek
Modified: 2016-11-03 17:02 EDT (History)
2 users (show)

See Also:
Fixed In Version: firewalld-0.4.2-1.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-11-03 17:02:04 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description lejeczek 2015-12-18 13:49:55 EST
Description of problem:

I prepare an xml:

<service>
  <short>Xelerance l2tpd</short>
  <description>A Layer 2 Tunneling Protocol VPN client/daemon for Linux and other POSIX-based OSs. Based off of L2TPd 0.61.</description>
  <port protocol="udp" port="1701"/>
</service>

I execute:
$ firewall-cmd --permanent --new-service=xl2tpd
I see file got copied into /etc/firewalld/services/ but
$ firewall-cmd --get-services
show no such service, so I do: systemctl restart firewalld - now --get-services list it but I end up with:

<?xml version="1.0" encoding="utf-8"?>
<service>
</service>

effectively having no results on iptables after adding the service to a zone


Version-Release number of selected component (if applicable):

firewalld-0.3.9-11.el7.noarch

How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:
Comment 2 Thomas Woerner 2016-01-18 06:55:55 EST
--new-service creates a new service, but is not using a local file for this. This would be very good to add, though.
Comment 3 Thomas Woerner 2016-01-18 06:57:29 EST
I think about --new-service-from-file=<file> or --new-service=<name> --file=<file>
Comment 4 lejeczek 2016-01-18 08:50:43 EST
I see.. Yes, it would be very useful indeed to be able to use prepped file.
Comment 5 lejeczek 2016-01-18 11:39:36 EST
also, if I may, --service-info which could dump whole lot about service would be nice too.
Comment 6 lejeczek 2016-01-27 12:33:29 EST
and would it great not to have to reload the daemon to see this newly added service.
Comment 7 lejeczek 2016-01-27 13:03:06 EST
I've just come across something, I've tried man pages but could not find any info on '&' char. 
And it seems that if it is in .xml file (I had in <description>) then firewalld omits silently.
Comment 8 Thomas Woerner 2016-01-28 07:59:18 EST
The ampersand is a special character in XML: https://en.wikipedia.org/wiki/List_of_XML_and_HTML_character_entity_references

If you are writing into an XML file, you need to take care about the syntax.
Comment 9 lejeczek 2016-01-28 08:34:50 EST
yes, but this - if one makes one mistake in one .xml then the rest, if there are other custom services xmls, get silently skipped! Services are there listed as attached to zones but ports are not opened!

test it - make a mistake in <port> eg. put 443,444 instead of 443-444 (and I imagine many of us will be makeing it, old iptables style habit) and all custom services are affected.
I'd be nice to have firewalld resilient to this.
Comment 11 Thomas Woerner 2016-01-28 13:21:32 EST
(In reply to lejeczek from comment #9)
> yes, but this - if one makes one mistake in one .xml then the rest, if there
> are other custom services xmls, get silently skipped! Services are there
> listed as attached to zones but ports are not opened!
> 

Please open an extra bug for this - it is a different issue.
Comment 17 errata-xmlrpc 2016-11-03 17:02:04 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-2597.html

Note You need to log in before you can comment on or make changes to this bug.